/**
 * Alarm
 * @id {string} int for push notification
 * @active {boolean}
 * @time {string} formatted hh:mm A
 * @date {string} ISO string
 * @message {string} Alarm message
 * @snooze {int}
 */
import { Alarm as AlarmType } from "../Types";
export declare class Alarm {
    id: string | number;
    active: boolean;
    date: string;
    message: string;
    snooze: number;
    userInfo?: Record<string, any>;
    oid?: string | number;
    ticker?: string | undefined;
    autoCancel: boolean;
    largeIcon?: string | undefined;
    smallIcon?: string | undefined;
    bigText?: string | undefined;
    subText?: string | undefined;
    color: string;
    vibrate: boolean;
    vibration: number;
    tag?: string | undefined;
    group?: string | undefined;
    ongoing: boolean;
    priority?: "max" | "high" | "low" | "min" | "default" | undefined;
    visibility?: "private" | "public" | "secret" | undefined;
    importance?: "default" | "max" | "high" | "low" | "min" | "none" | "unspecified" | undefined;
    allowWhileIdle: boolean;
    ignoreInForeground: boolean;
    title?: string | undefined;
    playSound: boolean;
    soundName?: string | undefined;
    number?: string | number | undefined;
    actions?: string[] | undefined;
    constructor({ id, active, date, message, snooze, userInfo, ticker, autoCancel, largeIcon, smallIcon, bigText, subText, color, vibrate, vibration, tag, group, ongoing, priority, visibility, importance, allowWhileIdle, ignoreInForeground, title, playSound, soundName, number, actions, }: AlarmType);
}
export default Alarm;
